



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>PHP PDO 预处理语句与存储过程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">PHP PDO 预处理语句与存储过程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 11:28:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>很多更成熟的数据库都支持预处理语句的概念。</p>
<p>什么是预处理语句？可以把它看作是想要运行的 SQL 的一种编译过的模板，它可以使用变量参数进行定制。预处理语句可以带来两大好处：</p>
<ul><li>查询仅需解析（或预处理）一次，但可以用相同或不同的参数执行多次。当查询准备好后，数据库将分析、编译和优化执行该查询的计划。对于复杂的查询，此过程 要花费较长的时间，如果需要以不同参数多次重复相同的查询，那么该过程将大大降低应用程序的速度。通过使用预处理语句，可以避免重复分析/编译/优化周 期。简言之，预处理语句占用更少的资源，因而运行得更快。</li>
<li>提供给预处理语句的参数不需要用引号括起来，驱动程序会自动处理。如果应用程序只使用预处理语句，可以确保不会发生SQL 注入。（然而，如果查询的其他部分是由未转义的输入来构建的，则仍存在 SQL 注入的风险）。</li></ul>
<p>预处理语句如此有用，以至于它们唯一的特性是在驱动程序不支持的时PDO 将模拟处理。这样可以确保不管数据库是否具有这样的功能，都可以确保应用程序可以用相同的数据访问模式。</p>
<h3>用预处理语句进行重复插入</h3>
<p>下面例子通过用 name 和 value 替代相应的命名占位符来执行一个插入查询</p>
<pre class="prettyprint linenums">&lt;?php<br />
$stmt = $dbh-&gt;prepare("INSERT INTO REGISTRY (name, value) VALUES (:name, :value)");<br />
$stmt-&gt;bindParam(':name', $name);<br />
$stmt-&gt;bindParam(':value', $value);

// 插入一行<br />
$name = 'one';<br />
$value = 1;<br />
$stmt-&gt;execute();

//  用不同的值插入另一行<br />
$name = 'two';<br />
$value = 2;<br />
$stmt-&gt;execute();<br />
?&gt;</pre>
<h3>用预处理语句进行重复插入</h3>
<p>下面例子通过用 name 和 value 取代 ? 占位符的位置来执行一条插入查询。</p>
<pre class="prettyprint linenums">&lt;?php<br />
$stmt = $dbh-&gt;prepare("INSERT INTO REGISTRY (name, value) VALUES (?, ?)");<br />
$stmt-&gt;bindParam(1, $name);<br />
$stmt-&gt;bindParam(2, $value);

// 插入一行<br />
$name = 'one';<br />
$value = 1;<br />
$stmt-&gt;execute();

// 用不同的值插入另一行<br />
$name = 'two';<br />
$value = 2;<br />
$stmt-&gt;execute();<br />
?&gt;</pre>
<h3>使用预处理语句获取数据</h3>
<p>下面例子获取数据基于键值已提供的形式。用户的输入被自动用引号括起来，因此不会有 SQL 注入攻击的危险。</p>
<pre class="prettyprint linenums">&lt;?php<br />
$stmt = $dbh-&gt;prepare("SELECT * FROM REGISTRY where name = ?");<br />
if ($stmt-&gt;execute(array($_GET['name']))) {<br />
  while ($row = $stmt-&gt;fetch()) {<br />
    print_r($row);<br />
  }<br />
}<br />
?&gt;</pre>
<p>如果数据库驱动支持，应用程序还可以绑定输出和输入参数.输出参数通常用于从存储过程获取值。输出参数使用起来比输入参数要稍微复杂一些，因为当绑定一个输出参数时，必须知道给定参数的长度。如果为参数绑定的值大于建议的长度，就会产生一个错误。</p>
<h3>带输出参数调用存储过程</h3>
<pre class="prettyprint linenums">&lt;?php<br />
$stmt = $dbh-&gt;prepare("CALL sp_returns_string(?)");<br />
$stmt-&gt;bindParam(1, $return_value, PDO::PARAM_STR, 4000); 

// 调用存储过程<br />
$stmt-&gt;execute();

print "procedure returned $return_value\n";<br />
?&gt;</pre>
<p>还可以指定同时具有输入和输出值的参数，其语法类似于输出参数。在下一个例子中，字符串"hello"被传递给存储过程，当存储过程返回时，hello 被替换为该存储过程返回的值。</p>
<h3>带输入/输出参数调用存储过程</h3>
<pre class="prettyprint linenums">&lt;?php<br />
$stmt = $dbh-&gt;prepare("CALL sp_takes_string_returns_string(?)");<br />
$value = 'hello';<br />
$stmt-&gt;bindParam(1, $value, PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT, 4000); 

// 调用存储过程<br />
$stmt-&gt;execute();

print "procedure returned $value\n";<br />
?&gt;</pre>
<h3>占位符的无效使用</h3>
<pre class="prettyprint linenums">&lt;?php<br />
$stmt = $dbh-&gt;prepare("SELECT * FROM REGISTRY where name LIKE '%?%'");<br />
$stmt-&gt;execute(array($_GET['name']));

// 占位符必须被用在整个值的位置<br />
$stmt = $dbh-&gt;prepare("SELECT * FROM REGISTRY where name LIKE ?");<br />
$stmt-&gt;execute(array("%$_GET[name]%"));<br />
?&gt;</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv1jmjq.html">ubuntu 报错： The system is running in low-graphics mode</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pk24k8.html">【皇甫】☀Struts&lowbar;第一节课</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2g7xl8.html">WebKit技术内幕</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7j4k1q.html">拿到阿里，网易游戏，腾讯，smartx的offer的过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m6o3p9.html">JS实现设为首页与加入收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql3d2xq.html">pip install 出现报asciii码错误的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw3x5y9.html">数位类统计问题--数位DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnn530q.html">MySql的导入与导出</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1yppj8.html">1176&period; Hyperchannels（欧拉回路）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmx2ml9.html">C语言的数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eye24e9.html">Android 应用内HttpClient 与 WebView 共享 Cookie</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meedorq.html">decorate pattern 装饰模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rzvz48.html">周强 201771010141面向对象程序设计（java）》第十七周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25wgewq.html">VritualBox安装CentOS及安装增强工具图文教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oz1dx8.html">C&num;多线程--信号量（Semaphore）&lbrack;z&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oo4dk8.html">&lbrack;android&rsqb; 采用服务录制电话&amp;amp&semi;服务的生命周期</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy2e4n9.html">json和jsonp的使用区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/960woj39.html">iOS UI基础-8&period;0 UIAlertView使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll4rdxq.html">MySQL Transaction--Sprint中访问只读从库的设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/963njgn9.html">问答项目---用户注册的那些事儿（JS验证）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdjozjvq.html">相同类型的对象不能互相转换：java&period;lang&period;ClassCastException&colon; com&period;anhoo&period;po&period;UserPo cannot be cast to com&period;anhoo&period;po&period;UserPo</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o45yvlq.html">cocos2d-x 2&period;0&period;2升级后某些函数变化（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pn7vn8.html">深度分析：Android4&period;3下MMS发送到附件为音频文件（音频为系统内置音频&rpar;的彩信给自己，添加音频-发送彩信-接收彩信-下载音频附件-预览-播放（三，接收彩信&amp;lt&semi;2，下载彩信&amp;gt&semi;）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn5wx2q.html">Python 字典的遍历</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve0jnz9.html">OC基础&colon;block&period;字面量                                                    分类：            ios学习 OC             2015-06-22 19&colon;08    155人阅读    评论&lpar;0&rpar;    收藏</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl0n6y9.html">HDU 4585</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vjwv2q.html">7&period;3   5种IO模型与IO复用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn54ejq.html">C高级第一次PTA作业 要求三</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl0zrk9.html">Softmax回归介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/953jnk68.html">如何用移动硬盘安装win7 系统</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
